/*!
 * @file      MemoSendDlg.h
 * @brief     ޸ â Model и ۾
 * @author    Yangjae.park(yangjae.park@nhn.com)
 * @date      2012-02-22 
 * @warning   
 */
#pragma once
#include "stdafx.h"
#include "afxhtml.h"
#include "afxwin.h"
#include "afxcmn.h"
#include "SkinDialog.h"
#include "NTalk.h"
#include "NoteModel.h"
#include "SmartEditor.h"
#include "MemoListCtrl.h"
#include "InfoUserMgrWnd.h"
#include "MemoSendAttachWnd.h"
#include "RsvDlg.h"
#include "SendMemoButtons.h"

#define COMMON_EDIT_BORDER_COLOR			RGB(201,201,201)
#define COMMON_EDIT_HEIGHT					(22)
#define COMMON_TEXT_COLOR					RGB(34,34,34)
#define NSD_COMMON_BG_COLOR					RGB(255,255,255)

//ʱ ġ 
#define NSD_DEF_MIN_SIZE_WIDTH				(600)
#define NSD_DEF_MIN_SIZE_HEIGHT				(588)
#define NSD_DEF_MIN_SIZE_EXPAND_HEIGHT		(720)
#define NSD_DEF_TITLE_BAR_HEIGHT			(26)

//޴  
#define NSD_DEF_RECV_USER_POS_X				(19)
#define NSD_DEF_RECV_USER_POS_Y				(40-NSD_DEF_TITLE_BAR_HEIGHT)
#define NSD_DEF_RECV_USER_WIDTH				(55)
#define NSD_DEF_RECV_USER_HEIGHT			(16)

// .
#define NSD_DEF_TITLE_POS_X					(19)
#define NSD_DEF_TITLE_POS_Y					(67-NSD_DEF_TITLE_BAR_HEIGHT)
#define NSD_DEF_TITLE_WIDTH					(50)
#define NSD_DEF_TITLE_HEIGHT				(16)

//޴» Ʈڽ
#define NSD_DEF_RECV_USER_EDIT_POS_X		(78+1)//  ׷ֱ   +1ȼ ʿϴ
#define NSD_DEF_RECV_USER_EDIT_POS_Y		(37-NSD_DEF_TITLE_BAR_HEIGHT+1)
#define NSD_DEF_RECV_USER_EDIT_WIDTH		(418-2)

//޴» ߰ ư
#define NSD_DEF_ADD_USER_BUTTON_POS_X		(496)
#define	NSD_DEF_ADD_USER_BUTTON_POS_Y		(37-NSD_DEF_TITLE_BAR_HEIGHT)
#define NSD_DEF_ADD_USER_BUTTON_WIDTH		(23)
#define	NSD_DEF_ADD_USER_BUTTON_HEIGHT		(24)

// Ʈڽ
#define NSD_DEF_TITLE_EDIT_POS_X			(78+1)
#define NSD_DEF_TITLE_EDIT_POS_Y			(NSD_DEF_RECV_USER_EDIT_POS_Y+COMMON_EDIT_HEIGHT+3 +1)
#define NSD_DEF_TILTE_EDIT_WIDTH			(376-2)

//߼ۿ üũڽ
#define NSD_DEF_RSV_CHECK_POS_X				(460)
#define NSD_DEF_RSV_CHECK_POS_Y				(NSD_DEF_TITLE_EDIT_POS_Y+7)
#define NSD_DEF_RSV_CHECK_WIDTH				(67)
#define NSD_DEF_RSV_CHECK_HEIGHT			(16)

// üũڽ
#define NSD_DEF_PARTY_CHECK_POS_X			(460)
#define NSD_DEF_PARTY_CHECK_POS_Y			(NSD_DEF_TITLE_EDIT_POS_Y+20)
#define NSD_DEF_PARTY_CHECK_WIDTH			(75)
#define NSD_DEF_PARTY_CHECK_HEIGHT			(16)


//Ʈ  
#define NSD_DEF_SMARTEDITOR_POS_X			(0)
#define NSD_DEF_SMARTEDITOR_POS_Y			(96-NSD_DEF_TITLE_BAR_HEIGHT)
#define NSD_DEF_SMARTEDITOR_WIDTH			(540)
#define NSD_DEF_SMARTEDITOR_HEIGHT			(338)

// ߰ ư
#define NSD_DEF_ADD_FILE_BUTTON_POS_X		(438)
#define NSD_DEF_ADD_FILE_BUTTON_POS_Y		(443-NSD_DEF_TITLE_BAR_HEIGHT)
#define NSD_DEF_ADD_FILE_BUTTON_POS_WIDTH	(37)
#define NSD_DEF_ADD_FILE_BUTTON_POS_HEIGHT	(20)

//ϸƮ ġ
#define NSD_DEF_FILE_LIST_POS_X				(19)
#define NSD_DEF_FILE_LIST_POS_Y				(470-NSD_DEF_TITLE_BAR_HEIGHT)
#define NSD_DEF_FILE_LIST_WIDTH				(500)
#define NSD_DEF_FILE_LIST_HEIGHT			(72)

// ޱ ư
#define NSD_DEF_SEND_BUTTON_POS_X			(201)
#define NSD_DEF_SEND_BUTTON_POS_Y			(554-NSD_DEF_TITLE_BAR_HEIGHT)
#define NSD_DEF_SEND_BUTTON_WIDTH			(58)
#define NSD_DEF_SEND_BUTTON_HEIGHT			(28)

#define NSD_DEF_CANCEL_BUTTON_POS_X			(263)
#define NSD_DEF_CANCEL_BUTTON_POS_Y			(554-NSD_DEF_TITLE_BAR_HEIGHT)
#define NSD_DEF_CANCEL_BUTTON_WIDTH			(58)
#define NSD_DEF_SEND_BUTTON_HEIGHT			(28)

#define DEF_USERMGR_REL_LEFT_POS_X			(78)
#define DEF_USERMGR_REL_RIGHT_POS_X			(20)
#define DEF_USERMGR_REL_TOP_POS_Y			(10)

#define ID_MEMO_USERMGR						(0xE070)
#define TIMER_HTMLEDITCTRL_SETFONT			1001
#define MAXFILENAME							1024


#define ID_MEMO_FILELIST					(0xE071)

class MemoDropTarget;
class MemoFileDropTarget;
class FileUploadController;
class SendMemoController;
class CCreateSendNoteDlgThread;

class CMemoSendDlg : public CSkinDialog,
	public CNoteModel,
	private CAMSWnd,
	private CAMSWnd::PlacementHook,
	private IOKCancelButtonsCallBack
{
	DECLARE_DYNAMIC(CMemoSendDlg)
public:
	CMemoSendDlg();  
	virtual ~CMemoSendDlg();

	BOOL				Create(UINT nIDTemplate,CWnd* pParentWnd/* =NULL */);
	BOOL				Create(CString strWriteModeParam, ULONGLONG lNoteNum,UINT nIDTemplate,CWnd* pParentWnd  =NULL,CWnd* pCreationDlg = NULL);
	BOOL				Create(const std::vector<ReceiverInfo>& receiverVector, UINT nIDTemplate,CWnd* pParentWnd/* =NULL */);
	BOOL				Create(const std::vector<ReceiverInfo>& receiverVector, const std::vector<AttachFileInfo>& attachFileVector, UINT nIDTemplate,CWnd* pParentWnd/* =NULL */);
	vector<ReceiverInfo>* GetReceiverInfo();
	CString				SearchUserName(CString strUserID);
	void				SetReadOnly( BOOL bStatus );
	bool				IsInitializeSuccess(void);
	
	void				EnableSend();
	void				DisableSend();
	virtual void		OnButtonClicked(COKCancelButtons::BUTTONS button);	
public:
	enum { IDD = IDD_MEMO_SEND_DIALOG };

protected:
	virtual void		DoDataExchange(CDataExchange* pDX); 
	virtual BOOL		PreTranslateMessage(MSG* pMsg);
	
	DECLARE_MESSAGE_MAP()
	virtual BOOL		OnInitDialog();
	virtual void		PostNcDestroy();

	trid_t				m_tridGetAttachID;
	trid_t				m_tridGetReplyBody;
	trid_t				m_tridSendNote;

public:
	void				SetReplyBodyTrid(trid_t &trid) { m_tridGetReplyBody = trid; }
	void				SetSendNoteTrid(trid_t &trid) { m_tridSendNote = trid; }

	virtual bool		OnResponseGetAttachID(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, LPCSTR szAttachID);
	virtual bool		OnResponseGetReplyBody(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, NoteReplyBody &replyBodyInfo);
	virtual bool		OnResponseSendNote(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode nWasErrorCode, int nJsonErrorCode, LPCWSTR strResponseMsg);

public:
	afx_msg void		OnBnClickedButton2();
	afx_msg void		OnPaint();
	afx_msg void		OnDestroy();
	afx_msg LRESULT		OnNcHitTest(CPoint point);
	afx_msg void		OnSize(UINT nType, int cx, int cy);	
	afx_msg void		OnNcLButtonUp(UINT nHitTest, CPoint point);
	afx_msg void		OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL		OnEraseBkgnd(CDC* pDC);	
	afx_msg void		OnBnClickedSendButton();
	afx_msg void		OnBnClickedCancelButton();	
	afx_msg void		OnRsvSelectedChange();
	afx_msg void		OnBnClickedNotiButton();
	afx_msg int			OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg LRESULT		OnMemoFileSendProcess(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnMemoFileSendCancel(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnMemoFileSendListDelete(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnMemoFileSendServerError(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnMemoFileSendResultWait(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnMemoFileSendResultComplete(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnUserMgrDelUser(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnUserMgrUserInfo(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnUserMgrResize(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnUserMgrAddUserBtn(WPARAM wParam, LPARAM lParam);
	afx_msg void		OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void		OnEnUpdateTitleEdit();
	afx_msg void		OnEnKillfocusTitleEdit();
	afx_msg HBRUSH		OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void		OnSetFocus(CWnd* pOldWnd);
	afx_msg LRESULT		OnMessageBoxClose(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnMessageBox(WPARAM wParam,	LPARAM lParam);
	LRESULT				OnBnClickedSendMemoMenuButton(WPARAM wParam, LPARAM lParam);

	void				__ResourceLoad(BOOL bInit = FALSE);
	void				ReSizeCtrl(void);
	void				SetMemoTitle(CString strTitle);
	void				SetMemoDocument(CString strDocument);
	BOOL				AddAttachFileList(CString strPath);
	bool				IsCloseMsg( MSG* pMsg );
	void				AddUser(std::vector<NE_MEMBER_DATA>& vAddUsers);	//  ߰ â  ý ȣѴ.


	void				CloseRecvNoteDlg();

	void				SetAddresseeVector(const std::vector<ReceiverInfo>& receiverVector) { m_receiverVector = receiverVector; }
	void				SetSendType(CString strWriteModeParam);
	void				SetNoteNo(ULONGLONG lNoteNum) { m_lNoteNum = lNoteNum; }
	void				SetAttachFileListVector(const std::vector<AttachFileInfo>& attachFileVector) { m_attachFileInfoVector = attachFileVector; }
	void				SetPreCreationDialog(CWnd* pCreationDlg) { m_pCreationDlg = pCreationDlg; }
	void				RecvMemoDlgIsClosed( CDialog* pDialog );

	void				RegisterWindowClassFileListAddressee();
	void				InitializeBySendType();
	void				InitializeAttachFileList();
	void				InitializeAddressee();
	void				InitializeSmartEditor();
	void				InitializeAll();
	void				IsReplyContent(BOOL bReplyContent){m_bReplyContent=bReplyContent;}
	void				SetTitleEdit();
	void				SetWindowTextAndSize();
	BOOL				SetUserBottomPNGBK(CString strPath);
	BOOL				SetUserBottomPNG(CString strPath);
	void				CloseDialog();
	CString				ExecScript2(CString strFunction);

	bool				SetNoteInfo(CString strTitle, CString strContent);
	void				SetSmartEditorFocus();
	void				SetDefaultExpand(bool bExpand);

private:	
	void				OnExpandChanged(bool bExpand, int nDy);
	const CString		GetSmartEditorDocument();
	void				SetSkin();
	void				SetDragAndDrop();
	BOOL				AddRecvUser(CString strID, CString strName=L"", int nAddUserCount=0);
	bool				IsNeedToOmmit( ReceiverInfo &receiverInfo );
	
	CEdit				m_edMemoTitle;
	BOOL				m_bShowTitleEdit;
	
	COKCancelButtons	*m_pMSButtons;
	CInfoUserMgrWnd		m_wndUserMgr;
	CMemoSendAttachWnd	m_wndFileList;
	

	BOOL				m_bUserMgrResize;
	int					m_nUserMgrDiffHeight;	

	ULONGLONG			m_lNoteNum;				// ߽ ȣ
	int					m_nTotalSize;
	BOOL				m_bFileLimit;			// ÷θ Ѵ
	CRect				m_rcTitle;				//޴»   κ

	CRect				m_rcTitleEdit;			//Ʈ RECT
	CString				m_strWriteMode;
	CString				m_strJSParam;			//ڹٽũƮ Ķ.
	CSmartEditor		m_SmartEditor;
	CRsvDlg				m_RsvDlg;

	bool				m_bDefaultExpand;

	MemoDropTarget		*m_pDropTarget;  //lint !e1516
	MemoFileDropTarget	*m_pFileDropTarget;
	bool				m_bInitializeSuccess;
	SendMemoController *m_pSendMemoController;
	CWnd				*m_pCreationDlg;
	CString				m_strTiTle;

	BOOL				m_bReplyContent;	//  ü , FW ϶..
	BOOL				m_bSetNoteInfo;		// ,  ̸ ?
	BOOL				m_bSetFocus;
	CString				m_strNoteContent;
	void ExecScript(const CString &strFunction);
	CString				m_strErrMsg;
	bool				m_bTopMost;
	HBRUSH				m_hBrushReserve;
	HBRUSH				m_hBrushParty;

	void OnMenuTopMost();
	void OnMenuAddUser();
	void OnMenuAddFile();
	void OnMenuReservation();

public:
	DECLARE_EVENTSINK_MAP()
	void DocumentCompleteExplorer1(LPDISPATCH pDisp, VARIANT* URL);
	CButton m_chkParty;
	afx_msg void OnBnClickedPartyCheck();
	void SetForegroundWindowForce(HWND hWnd);

	afx_msg void OnTimer(UINT_PTR nIDEvent);
};
